<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Barnsley Fern Generator</title>
</head>
<style>
  #viewer {
    background-color: #070400;
    border: 1px solid green;
    border-radius: 4px;
    position: relative;
    left: 50%;
    transform: translateX(-50%);
  }

  h1 {
    text-align: center;
  }
</style>
<script>
  document.addEventListener('DOMContentLoaded', () => {
    const canvas = document.querySelector('#viewer');
    canvas.height = 700, canvas.width = 700;
    const ctx = canvas.getContext('2d');

    // const iteration = 99999;

    window.requestAnimationFrame(() => draw(0, 0));
  });

  const draw = (initX, initY) => {
    const canvas = document.querySelector('#viewer');
    const ctx = canvas.getContext('2d');

    const rand = Math.random();
    const [x, y] = (rand <= 0.01) ? f1(initX, initY) :
      (rand <= 0.86) ? f2(initX, initY) :
        (rand <= 0.86 + 0.07) ? f3(initX, initY) :
          f4(initX, initY);

    // Render Generated Point
    ctx.beginPath();
    ctx.fillStyle = 'lightgreen';

    ctx.fillRect(x * 110 + canvas.width / 2, canvas.height - y * 70, 1, 1);

    window.requestAnimationFrame(() => draw(x, y));

  }

  // Affine Transformation
  const f1 = (x, y) => [0, 0.16 * y];    // Stem. Call 1% of time
  const f2 = (x, y) => [0.85 * x + 0.04 * y, -0.04 * x + 0.85 * y + 1.6];  // Successively smaller leaflets. Call 85% of time
  const f3 = (x, y) => [0.2 * x - 0.26 * y, 0.23 * x + 0.22 * y + 1.6];   // Largest left-hand leaflet. Call 7% of time
  const f4 = (x, y) => [-0.15 * x + 0.28 * y, 0.26 * x + 0.24 * y + 0.44];  // Largest right-hand leaflet. Call 7% of time
</script>

<body>
  <h1>Barnsley Fern</h1>
  <canvas id="viewer"></canvas>
</body>

</html>
